package blop.pong;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;

public class Pong extends Activity
{
    private SplashView sv;
    private PongView pv;
    private Game g;
    private GamePlay gp;
    private TouchScreen ts;
    private Freq audio_freq;
    private GameState gs;
    private Splash s;
    private Handler h;

    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        android.util.Log.d("blop", "onCreate() savedInstanceState == null: " +
                           (savedInstanceState == null));
        if (savedInstanceState != null)
          android.util.Log.d("blop", "savedInstance not null, splash saved = " + savedInstanceState.getBoolean("splash"));
        pv = new PongView(this);
        audio_freq = new Freq();
        audio_freq.freq = 440;
        g = new Game(100, 100, 40, audio_freq, this);
        ts = new TouchScreen(g);
        pv.setOnTouchListener(ts);
        pv.set_game(g);
        gs = new GameState();
        if (savedInstanceState != null)
          gs.in_splash = savedInstanceState.getBoolean("splash");
        h = new Handler() {
          public void handleMessage(Message m) {
            if (m.what == 0)
              setContentView(sv);
            else
              setContentView(pv);
          }
        };
        gs.set_handler(h);
        gs.set_game(g);
        sv = new SplashView(this, gs);
        gs.set_splash_view(sv);
        gs.set_pong_view(pv);
        gs.set_activity(this);
        gs.set_freq(audio_freq);
        setContentView(sv);

android.util.DisplayMetrics metrics = new android.util.DisplayMetrics();
getWindowManager().getDefaultDisplay().getMetrics(metrics);
android.util.Log.d("blop", "xdpi " + metrics.xdpi + " ydpi " + metrics.ydpi + " h " + metrics.heightPixels + " w " + metrics.widthPixels + " density " + metrics.density + " densityDpi " + metrics.densityDpi + " scaledDensity " + metrics.scaledDensity);
    }

    public void onResume()
    {
      super.onResume();
      android.util.Log.d("blop", "onResume()");
      gs.start();
    }

    public void onPause()
    {
      super.onPause();
      android.util.Log.d("blop", "onPause()");
      gs.stop();
    }

    protected void onSaveInstanceState(Bundle outState)
    {
      super.onSaveInstanceState(outState);
      android.util.Log.d("blop", "onSaveInstanceState called, setting splash to " + gs.in_splash);
      outState.putBoolean("splash", gs.in_splash);
    }
}
