package blop.pong;

import android.graphics.Canvas;
import android.graphics.Paint;
import android.view.View;
import java.util.Random;
import java.util.concurrent.Semaphore;
import android.media.MediaPlayer;

class Splash extends Thread
             implements MediaPlayer.OnCompletionListener
{
  public static final int [][]init_logo = {
    {22, 61},
    {31, 61},
    {40, 61},
    {50, 61},
    {60, 61},
    {69, 61},
    {78, 62},
    {83, 70},
    {83, 80},
    {82, 89},
    {72, 97},
    {62, 95},
    {59, 87},
    {58, 79},
    {59, 70},
    {21, 127},
    {31, 127},
    {41, 128},
    {49, 128},
    {58, 128},
    {68, 128},
    {77, 128},
    {61, 148},
    {71, 149},
    {80, 154},
    {81, 164},
    {81, 174},
    {72, 182},
    {64, 183},
    {55, 176},
    {52, 167},
    {53, 157},
    {36, 154},
    {35, 179},
    {57, 205},
    {66, 206},
    {76, 206},
    {85, 206},
    {93, 206},
    {102, 206},
    {109, 206},
    {54, 212},
    {53, 221},
    {53, 229},
    {61, 237},
    {71, 237},
    {76, 232},
    {79, 223},
    {79, 216},
    {125, 65},
    {119, 59},
    {119, 49},
    {120, 41},
    {130, 38},
    {138, 41},
    {140, 50},
    {143, 57},
    {149, 66},
    {156, 67},
    {163, 58},
    {163, 50},
    {160, 40},
    {155, 35},
    {106, 91},
    {116, 91},
    {125, 91},
    {135, 91},
    {142, 91},
    {151, 91},
    {160, 98},
    {160, 107},
    {153, 116},
    {122, 98},
    {122, 106},
    {139, 141},
    {148, 141},
    {157, 141},
    {164, 149},
    {164, 159},
    {164, 166},
    {159, 174},
    {149, 174},
    {139, 174},
    {106, 227},
    {115, 228},
    {124, 228},
    {133, 228},
    {143, 228},
    {153, 227},
    {162, 227},
    {164, 219},
    {164, 211},
    {162, 204},
    {155, 196},
    {148, 197},
    {140, 203},
    {140, 211},
    {136, 220},
    {134, 248},
    {143, 248},
    {152, 249},
    {161, 249},
    {118, 249},
    {142, 271},
    {152, 272},
    {161, 278},
    {161, 286},
    {160, 295},
    {151, 302},
    {141, 302},
    {134, 295},
    {134, 286},
    {135, 276}, 
  };
  public static final int [][]start_pos = new int[113][2];
  public static final int [][]pos = new int[113][2];
  public static final int [][]logo = new int[113][2];

  public static final int logo_width = 320;
  public static final int logo_height = 200;
  public static final Random rand = new Random();

  private GameState gs;
  private Sync finished;

  public Splash(GameState _gs) {
    gs = _gs;
    finished = new Sync(false);
  }

  public void onCompletion(MediaPlayer mp)
  {
    mp.release();
  }

  public static final int []bitmap = new int[64*64];

  public static final Paint mp = new Paint();

  public static final void draw(Canvas c, Paint p)
  {
    int i;
    c.drawARGB(255, 0, 0, 0);
    c.drawRGB(0, 0, 0);
    for (i = 0; i < 113; i++) {
      int x = pos[i][1] + rand.nextInt(5);
      int y = pos[i][0] + rand.nextInt(5);
//      c.drawRect(x, y, x+10, y+10, p);
        c.drawBitmap(bitmap, 0, 64, x-32, y-32, 64, 64, true, null);
    }
  }

  public void run()
  {
//  mp.setXfermode(new android.graphics.PorterDuffXfermode(android.graphics.PorterDuff.Mode.
//  ADD));
  try {
    int fps;
    int n_frames;
    int x;
    int y;
    int logo_size = logo.length;
    int i, j;

    for (i = 0; i < 64; i++)
    for (j = 0; j < 64; j++) {
      int alpha = (int)(((i-32)*(i-32) + (j-32)*(j-32))/2048.*255);
      if (alpha > 255) alpha = 255;
      alpha = 255-alpha;
      double a = alpha / 255.;
      a = 1 - Math.sqrt((i/32. - 1.) * (i/32. -1.) + (j/32.-1.)*(j/32.-1.));
      if (a < 0) a = 0; if (a > 1) a = 1;
      if (a > 0.8) a = 0.8; a /= 0.8;
      a = a*a*a;
      alpha = (int)(a * 255);
      if (alpha > 255) alpha = 255;
      bitmap[i*64+j] = 0xffffff | (alpha << 24);
    }
    fps = 25;
    n_frames = fps * 3;

    if (!gs.sv.good_size)
      try { gs.sv.wait_for_size.acquire(); }
      catch(Exception e) { throw new Exception(); }
    if (finished.get()) throw new Exception();

    MediaPlayer p = MediaPlayer.create(gs.a, R.raw.splash);
    p.setOnCompletionListener(this);
    p.start();

    for (i = 0 ; i < n_frames / 3; i++) {
      for (j = 0; j < logo_size; j++) {
        pos[j][0] = (int)gs.g.R3(i, 0, n_frames/3-1, start_pos[j][0], logo[j][0]);
        pos[j][1] = (int)gs.g.R3(i, 0, n_frames/3-1, start_pos[j][1], logo[j][1]);
      }
      gs.sv.postInvalidate();
      synchronized (this) { try { wait(1000/fps); } catch(Exception e) {}}
      if (finished.get()) throw new Exception();
    }

    for (i = 0 ; i < n_frames / 3 / 2; i++) {
      gs.sv.postInvalidate();
      synchronized (this) { try { wait(1000/fps); } catch(Exception e) {}}
      if (finished.get()) throw new Exception();
    }

    synchronized (gs) {
    for (i = 0; i < logo_size; i++) {
/*
      start_pos[i][0]=rand.nextInt(200) + 100 + gs.height;
      start_pos[i][1]=rand.nextInt(200) + 100 + gs.width;
 */
      start_pos[i][0]=-360*2+rand.nextInt(360*4);
      start_pos[i][1]=rand.nextInt(gs.width) + gs.width;
    }
    }

    for (i = 0 ; i < n_frames / 2; i++) {
      for (j = 0; j < logo_size; j++) {
/*
        pos[j][0] = (int)gs.g.R3(i, n_frames/3, 0, start_pos[j][0], logo[j][0]);
        pos[j][1] = (int)gs.g.R3(i, n_frames/3, 0, start_pos[j][1], logo[j][1]);
*/
        float angle = (float)(gs.g.R3(i, 0, n_frames/3, 0,  start_pos[j][0]) / 180. * gs.g.pi);
        float rho = gs.g.R3(i, 0, n_frames/3, 0, start_pos[j][1]);
        pos[j][0] = (int)(rho * Math.sin(angle) + logo[j][0]);
        pos[j][1] = (int)(rho * Math.cos(angle) + logo[j][1]);
      }
      gs.sv.postInvalidate();
      synchronized (this) { try { wait(1000/fps); } catch(Exception e) {}}
      if (finished.get()) throw new Exception();
    }
  } catch (Exception e) {};
    android.util.Log.d("blop", "Splash done");
    if (!finished.get()) gs.go_game();
  }

  public void die()
  {
    finished.set(true);
    interrupt();
  }

  public void set_size()
  {
    int i;
    synchronized (gs) {
    for (i = 0; i < 113; i++) {
      start_pos[i][0]=rand.nextInt(200) - 300;
      start_pos[i][1]=rand.nextInt(200) - 300;
      logo[i][0] = init_logo[i][0] + (gs.height-200)/2;
      logo[i][1] = init_logo[i][1] + (gs.width-320)/2;
    }
    }
  }
}
